# Subato Demo
Diese Demo konfiguriert Subato und alle benötigte Dienste, sodass das System lokal ausprobiert
werden kann. Dabei handelt es sich um eine minimale Konfiguration, dessen initiale Daten (Benutzer,
Kurse, ...) über die Verzeichnisse `keycloak-conf` und `seed` angepasst werden kann. Beispielkonfigurationen für einen professionellen Betrieb (mit einem Reverse Proxy, verschiedenen Umgebungen, HTTPS, Prometheus/Grafana und GitLab CI) stellen wir gerne auf Anfrage zur Verfügung. Weiterführende Informationen zur Konfiguration von Subato selbst befinden sich in der [Subato Dokumentation](../docs/config.md). Informationen zur Konfiguration der Keycloak-Instanz in dieser Demo finden sich im [keycloak-config-cli](https://github.com/adorsys/keycloak-config-cli) Repository.

Bei erstmaliger Einrichtung:

1. Docker installieren/konfigurieren
2. `cp .env.example .env` und Variablen ggf. anpassen
3. `./setup.sh`
4. `docker compose up`
5. Stoppen, dann `./seed.sh`

Anschließend mit `docker compose up` alle Dienste starten (oder selektiv einzelne Dienste mit z.B.
`docker compose up subato-web`). Die Demo kann mit `./reset.sh` zurückgesetzt werden, sodass alle
Daten gelöscht werden. Bei Änderungen am Frontend oder Backend `docker compose build subato-web`
(bzw. `subato`) nicht vergessen! In der
aktuellen Konfiguration stehen die Umgebungen `java19` und `python3.9` für die Lösungsauswertung zur
Verfügung. Weitere Umgebungen müssen mit z.B. `cd $EVA_DIR/environments && ./build.sh
python3.12` gebaut werden.

Man kann auch eine bereits existierende Subato-Datenbank verwenden. Dazu den Datenbank Dump (`.sql`-Datei) in einem Ordner `.sql` ablegen. Anschließend das vorhandene Datenverzeichnis `subato2-data` unter dem in `.env` konfigurierten Pfad ablegen. In diesem Fall entfällt Schritt 5 oben. Allerdings ist dann darauf zu achten, dass zumindest einer der Benutzer auch in der Keycloak-Konfiguration mit entsprechendem Usernamen und E-Mail Adresse vorhanden ist, damit man sich einloggen kann. **Achtung**: Wenn der `subato-db` Container bereits einmal gestartet wurde, muss der Container herunterfahren werden. Anschließend muss das Verzeichnis `.postgresql-data` gelöscht und der Container neu gestartet werden. Andernfalls wird die `.sql`-Datei nicht berücksichtigt!

| Dienst | URL |
| ------- | ---- |
| Subato Frontend | http://localhost:4200/ |
| Subato Backend | http://localhost:8081/ |
| Keycloak | http://keycloak.subato.local:8080/ |
| RabbitMQ Management | http://localhost:15672/ |
| Eva Registry | http://localhost:7777/ |

Es gibt die folgenden Testbenutzer mit verschiedenen Rollen. Das Passwort ist jeweils der Benutzername.

| Benutzername | Rollen |
| ------------- | ------- |
| turing | Super Admin |
| neumann | Staff |
| knuth | Student |
| hopper | Student |

